local addon = CreateFrame("Frame")
addon:RegisterEvent("ADDON_LOADED")
addon:RegisterEvent("PLAYER_LOGIN")
addon:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")


local Orig_CombatText_AddMessage
local playerGUID


-- prevent standard reflect combat message showing
function SpellBlocked_CombatText_AddMessage(message, ...)
	if message ~= REFLECT then
		Orig_CombatText_AddMessage(message, ...)
	end
end


addon:SetScript("OnEvent", function(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, combatEvent, _, _, _, destGUID, _, _, _, spellName, _, missType = ...
		if destGUID == playerGUID and combatEvent == "SPELL_MISSED" and missType == "REFLECT" and SHOW_COMBAT_TEXT == "1" then
			-- print our own combat message with the spell name included
			CombatText_AddMessage(REFLECT.. " "..spellName, COMBAT_TEXT_SCROLL_FUNCTION, 1, 1, 1)
		end
	elseif event == "PLAYER_LOGIN" then
		playerGUID = UnitGUID("player")
	elseif event == "ADDON_LOADED" and (...) == "Blizzard_CombatText" then
		-- hook CombatText_AddMessage so we can make our own
		Orig_CombatText_AddMessage = CombatText_AddMessage
		CombatText_AddMessage = SpellBlocked_CombatText_AddMessage
	end
end)